unit threadform;
(*
  Automaattilaskuri
  Esimerkkiohjelma sikeiden kytst.

  Ohjelma vaatii TLaskuri-komponentin asennettuna Delphiin.
  Projektin asetuksiin mukaan polku, jossa laskurikomponentti on.

  Miika Nurminen, 5.6.2004
*)
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, laskuri;

type
  TLaskuriThread = class(TThread)
  private
    sleeptime:integer;
    target:TLaskuri;
  protected
    procedure PerformAction;
    procedure Execute; override;
  public
    constructor Create(CreateSuspended: Boolean; Target: TLaskuri; sleeptime:integer); reintroduce; virtual;
  end;


  TFormThread = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Laskuri1: TLaskuri;
    Laskuri2: TLaskuri;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    thread1:TLaskuriThread;
    thread2:TLaskuriThread;
    procedure UpdateCaption(b:TButton;t:TThread);
    procedure doThread(b:TButton;t:TThread);
  public
  end;

var
  FormThread: TFormThread;

implementation

{$R *.dfm}

{ TMyThread }

constructor TLaskuriThread.Create(CreateSuspended: Boolean; Target: TLaskuri; SleepTime:integer);
begin
  self.sleeptime:=sleeptime;
  self.target:=target;
  inherited Create(CreateSuspended);
end;

procedure TLaskuriThread.Execute;
begin
  while not Terminated do begin
    if Target=nil then Break;
    Sleep(sleeptime);

    // Synchrozize-metodi varmistaa, ett kutsuttava koodi suoritetaan
    // psikeess. Tm on vlttmtnt ksiteltess useimpia
    // VCL-komponentteja, koska ne eivt yleisesti ole sieturvallisia!
    Synchronize(PerformAction);
    // ks. esim. Programming with Delphi: Using the main VCL/CLX thread
  end;
end;

procedure TLaskuriThread.PerformAction;
begin
  Target.Inc(1);
end;

procedure TFormThread.FormCreate(Sender: TObject);
begin
  Randomize;
  thread1:=TLaskuriThread.Create(true,Laskuri1,Random(100));
  thread1.FreeOnTerminate:=true;
  thread2:=TLaskuriThread.Create(true,Laskuri2,Random(100));
  thread2.FreeOnTerminate:=true;
  UpdateCaption(Button1,Thread1);
  UPdateCaption(Button2,Thread2);
  // jos olisi laajempi sovellus, kytettisiin taulukkorakennetta tai
  // omaa komponenttia.
end;

procedure TFormThread.Button1Click(Sender: TObject);
begin
  doThread(Button1,Thread1);
end;

procedure TFormThread.Button2Click(Sender: TObject);
begin
  doThread(Button2,Thread2);
end;


// Vaihtoehtoinen tapa captioneiden ksittelyyn ja sikeiden hallintaan olisi
// oma Action, tarkastus update-ksittelijss.
procedure TFormThread.UpdateCaption(b: TButton; t: TThread);
begin
  if t.Suspended then b.Caption:='Kynnist'
  else b.Caption:='Pysyt';
end;

procedure TFormThread.doThread(b:TButton; t: TThread);
begin
  t.Suspended:=not t.Suspended;
  UPdateCaption(b,t);
end;

procedure TFormThread.FormDestroy(Sender: TObject);
begin
  // lopettaa sikeiden suorituksen ja vapauttaa ne, koska FreeOnTerminate
  // on pll.
  Thread1.Terminate;
  Thread2.Terminate;
end;

end.

